<template>
    <div class="q-gutter-y-md">
        <div class="row " v-for="i in fields">
            <slot :name="`${i.key}Prepend`"/>
            <q-input v-if="i.baseType === 'basic'"
                     class="col"
                     :key="i.key"
                     :ref="i.key"
                     :error="hasError[i.key]"
                     :error-message="errors[i.key]"
                     :type="i.type"
                     label-slot
                     filled
                     :autogrow="i.autogrow"
                     :suffix="i.suffix"
                     :prefix="i.prefix"
                     :color="i.color"
                     :bg-color="i.bgColor"
                     :rules="i.rules" :value="value.models[i.key]"

                     @input="OnInput($event, i.key)"
            >
                <template v-slot:label>
                    <LabelSlot :icon="i.icon" :label="i.label"
                               :tooltip="i.tooltip"/>
                </template>
                <template v-slot:counter v-if="i.max!= null">
                    {{ value.models[i.key].length }}/{{ i.max }}
                </template>
            </q-input>
            <q-input v-else-if="i.baseType === 'number'"
                     class="col"
                     :key="i.key"
                     :ref="i.key"
                     :error="hasError[i.key]"
                     :error-message="errors[i.key]"
                     type="number"
                     label-slot
                     filled
                     :autogrow="i.autogrow"
                     :suffix="i.suffix"
                     :prefix="i.prefix"
                     :color="i.color"
                     :bg-color="i.bgColor"
                     @input="OnInput($event, i.key)"
                     :rules="i.rules" :value="value.models[i.key]">
                <template v-slot:label>
                    <LabelSlot :icon="i.icon" :label="i.label"
                               :tooltip="i.tooltip"/>
                </template>

            </q-input>
            <q-select v-else-if="i.baseType === 'select'"
                      class="col"
                      :key="i.key"
                      :ref="i.key"
                      :error="hasError[i.key]"
                      :error-message="errors[i.key]"
                      :multiple="i.multiple"
                      :transition-show="i.show"
                      :transition-hide="i.hide"
                      :clearable="i.clearable"
                      :use-chips="i.chip"
                      :emit-value="i.advance ? true  : undefined"
                      :map-options="i.advance ? true  : undefined"
                      :option-label="i.advance ? i.advance.labelKey : undefined"
                      :option-value="i.advance ? i.advance.valueKey : undefined"
                      :new-value-mode="i.newValueMode"
                      :use-input="i.newValueMode != null"
                      label-slot
                      filled
                      :options="i.options"
                      :color="i.color"
                      :bg-color="i.bgColor"
                      :option-disable="i.disableKey"
                      @input="OnInput($event, i.key)"
                      :value="value.models[i.key]">
                <template v-slot:label>
                    <LabelSlot :icon="i.icon" :label="i.label"
                               :tooltip="i.tooltip"/>
                </template>

                <template v-slot:option="scope" v-if="i.iconKey">
                    <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                        <q-item-section avatar v-if="i.iconKey">
                            <q-icon :name="scope.opt[i.iconKey]"/>
                        </q-item-section>
                        <q-item-section>
                            <q-item-label>
                                {{ scope.opt[i.advance.labelKey] }}
                            </q-item-label>
                        </q-item-section>
                    </q-item>
                </template>
            </q-select>
            <ColorInput v-else
                        class="col"
                        :key="i.key"
                        :ref="i.key"
                        :icon="i.icon"
                        :tooltip="i.tooltip"
                        :label="i.label"
                        :prefix="i.prefix"
                        :suffix="i.suffix"
                        :error="hasError[i.key]"
                        :error-message="errors[i.key]"
                        @input="OnInput($event, i.key)"
                        :value="value.models[i.key]"
            />
            <slot :name="`${i.key}Append`"/>
        </div>
    </div>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {BasicFormModel, FormElement} from "src/classLibrary/FormTypes";
import LabelSlot from "components/LabelSlot.vue"
import ColorInput from "components/Core/ColorInput.vue";

@Component({
    components: {ColorInput, LabelSlot}
})
export default class FormCore extends Vue {
    @Prop() fields!: FormElement[]
    @Prop() value!: BasicFormModel;

    @Prop() hasError: { [s: string]: boolean } = {}
    @Prop() errors: { [s: string]: string | null } = {}


    window = window;

    EmitEvent(v: BasicFormModel) {
        Vue.nextTick(() => {
            v.valid = this.fields.All(x => (this.$refs[x.key] as any)[0].validate())
            this.$emit('input', v);
        })
    }

    OnInput(e: BasicFormModel, i: string) {
        const v = this.value;
        v.models[i] = e;
        this.EmitEvent(v)
    }


}
</script>
